#include <stdio.h>
#include <stdlib.h>

int main()
{
    long long int m,n,s=0i,j,xi,yi,q,i;
    scanf("%lld lld", &n, &m);
    scanf("%lld", &q);
    scanf("%lld lld", &xi, &yi);
    long long int a[n][m];
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            scanf("%lld", &a[i][j]);
        }
    }
    for(i=0;i<q;i++)
    {
    scanf("%lld %lld", &xi, &yi);
    }
    a[n-1][m-1]=0;
    while(i!=n-1 && j!=m-1)
    {
        if(a[i+1][j]<a[i][j+1])
        {
            i++;
            s=s+a[i][j];
        }
        else
        {
            j++;
            s=s+a[i][j];
        }
        if(i==xi)
        {
            i--;
            j++;
            s=s+a[i][j];
        }
        if(j==yi)
        {
            j--;
            i++;
            s=s+a[i][j];
        }

    }
    }


    return 0;
}